#include "stdafx.h"
/*
  This file is a part of KMC software distributed under GNU GPL 3 licence.
  The homepage of the KMC project is http://sun.aei.polsl.pl/kmc
  
  Authors: Sebastian Deorowicz and Agnieszka Debudaj-Grabysz
  
  Version: 1.0
  Date   : 2014-02-17
*/
#include <algorithm>
#include <numeric>
#include <iostream>
#include "kb_writer.h"

using namespace std;


//************************************************************************************************************
// CKmerBinWriter
//************************************************************************************************************

//----------------------------------------------------------------------------------
// Assign queues and monitors
CKmerBinWriter::CKmerBinWriter(CKMCParams &Params, CKMCQueues &Queues, int n)
{
	mm_write_buffer    = Queues.mm_write_buffer;
	write_buffer_queue = Queues.write_buffer_queue[n];
}

//----------------------------------------------------------------------------------
CKmerBinWriter::~CKmerBinWriter()
{

}

//----------------------------------------------------------------------------------
// Store buffers to files
void CKmerBinWriter::ProcessQueue()
{
	FILE *file;
	uint64 size = 0;
	uchar* buffer = NULL;

	while(!write_buffer_queue->completed())
	{
		if(write_buffer_queue->pop(file, buffer, size) && size)
		{
			fwrite(buffer, 1, size, file);
			delete[] buffer;
			mm_write_buffer->decrease(size);
		}
	}
}


//************************************************************************************************************
// CWKmerBinWriter
//************************************************************************************************************

//----------------------------------------------------------------------------------
// Constructor
CWKmerBinWriter::CWKmerBinWriter(CKMCParams &Params, CKMCQueues &Queues, int n)
{
	kbw = new CKmerBinWriter(Params, Queues, n);
}

//----------------------------------------------------------------------------------
// Destructor
CWKmerBinWriter::~CWKmerBinWriter()
{
	delete kbw;
}

//----------------------------------------------------------------------------------
// Execution
void CWKmerBinWriter::operator()()
{
	kbw->ProcessQueue();
}
