/*
  This file is a part of KMC software distributed under GNU GPL 3 licence.
  The homepage of the KMC project is http://sun.aei.polsl.pl/kmc

  Authors: Sebastian Deorowicz and Agnieszka Debudaj-Grabysz

  Version: 1.0
  Date   : 2014-02-17
*/

#ifndef _KB_WRITER_H
#define _KB_WRITER_H

#include "defs.h"
#include "params.h"
#include "kmer.h"
#include "radix.h"
#include <string>
#include <algorithm>
#include <numeric>
#include <array>
#include <vector>
#include <stdio.h>
#include <boost/filesystem.hpp>

using namespace std;

//************************************************************************************************************
// CKmerBinWriter - writer of bins of k-mers
//************************************************************************************************************
class CKmerBinWriter {
	CWriteBufferQueue *write_buffer_queue;
	CMemoryMonitor *mm_write_buffer;

public:
	CKmerBinWriter(CKMCParams &Params, CKMCQueues &Queues, int n);
	~CKmerBinWriter();

	void ProcessQueue();
};

//************************************************************************************************************
// CWKmerBinWriter - wrapper for multithreading purposes
//************************************************************************************************************
class CWKmerBinWriter {
	CKmerBinWriter *kbw;

public:
	CWKmerBinWriter(CKMCParams &Params, CKMCQueues &Queues, int n);
	~CWKmerBinWriter();

	void operator()();
};

#endif

// ***** EOF
